import greenfoot.*; 
public class Player extends Actor
{   
    private int verticalSpeed=0;
    FuegoWorld thisGame;
    
    
    private GreenfootImage run1r = new GreenfootImage("sonicrun1.png");
    private GreenfootImage run2r = new GreenfootImage("sonicrun2.png");
    private GreenfootImage run3r = new GreenfootImage("sonicrun3.png");
    private GreenfootImage run4r = new GreenfootImage("sonicrun4.png");
    
    private GreenfootImage run1l = new GreenfootImage("sonicrun1l.png");
    private GreenfootImage run2l = new GreenfootImage("sonicrun2l.png");
    private GreenfootImage run3l = new GreenfootImage("sonicrun3l.png");
    private GreenfootImage run4l = new GreenfootImage("sonicrun4l.png");
    
    private GreenfootImage run1s = new GreenfootImage("sonicrun1s.png");
    private GreenfootImage run2s = new GreenfootImage("sonicrun2s.png");
    private GreenfootImage run3s = new GreenfootImage("sonicrun3s.png");
    private GreenfootImage run4s = new GreenfootImage("sonicrun4s.png");
    
    private GreenfootImage run1sl = new GreenfootImage("sonicrun1sl.png");
    private GreenfootImage run2sl = new GreenfootImage("sonicrun2sl.png");
    private GreenfootImage run3sl = new GreenfootImage("sonicrun3sl.png");
    private GreenfootImage run4sl = new GreenfootImage("sonicrun4sl.png");
    
    private GreenfootImage idl1 = new GreenfootImage("sonicidle1.png");
    private GreenfootImage idl2 = new GreenfootImage("sonicidle2.png");
    private GreenfootImage idl3 = new GreenfootImage("sonicidle3.png");
    
    private GreenfootImage jumpr = new GreenfootImage("sonicjumpl.png");
    private GreenfootImage jumpl = new GreenfootImage("sonicjumpr.png");
    private GreenfootImage jump1r = new GreenfootImage("sonicjump1.png");
    private GreenfootImage jump1l = new GreenfootImage("sonicjump1r.png");
    
    private GreenfootSound coinsound = new GreenfootSound ("coinsound1.wav");
    private GreenfootSound bombexplosion = new GreenfootSound ("bombexpl.wav");
    private GreenfootSound Heal = new GreenfootSound ("heal.wav");
    private int frame =1;
    private int framel =1;
    private int frames =1;
    private int framesl =1;
    private int framei = 1 ;
    private int frameC = 1 ;
    private int framej1 =1;
    private int framej2 =1;
    private int animationCounter=0;
    private int bombcounter = 200;
    private int coincounter = 100;
    private int healcounter = 1700;
    public void act() 
    {
        this.checkKeys();
        spawncoin();
        this.checkFalling();
        animationCounter ++;
        this.getOneObjectAtOffset(50,50,Player.class);
        Actor coin = getOneIntersectingObject(Coin.class);
        coinsound.setVolume ( 50 );
        Heal.setVolume ( 50 );
        bombexplosion.setVolume ( 50 );
        if(coin != null)
        {
          getWorld().removeObject(coin);
           thisGame.score++;
           coinsound.play();
        }
        Actor bomb = getOneIntersectingObject(bomb.class);
        if(bomb != null)
        { FuegoWorld fuegoworld = (FuegoWorld) getWorld();
          Hearts hearts = (Hearts) getOneIntersectingObject(Hearts.class); 
              fuegoworld.hearts.adjustHearts(-1);
          getWorld().removeObject(bomb);
          bombexpl();
          bombexplosion.play();
        }
        Actor heal = getOneIntersectingObject(heal.class);
        if(heal != null)
        {
          getWorld().removeObject(heal);
          FuegoWorld fuegoworld = (FuegoWorld) getWorld();
          fuegoworld.hearts.adjustHearts(+1);
          Heal.play();
        }
        
        spawnbomb();
        heal();
        if(healcounter <5000)
        if(Greenfoot.getRandomNumber(200) == 1){ healcounter+=1;}
        if(coincounter >20)
        if(Greenfoot.getRandomNumber(70) == 1){ coincounter-=1;}
        if(bombcounter >80)
        if(Greenfoot.getRandomNumber(100) == 1){ bombcounter-=1;}
    }    
    
    public void checkKeys()
    { 
         if (Greenfoot.isKeyDown("w"))
        {   
            if(this.getY()>275 )
            {
                this.jump();
                if (Greenfoot.isKeyDown("w") || (Greenfoot.isKeyDown("w") && Greenfoot.isKeyDown("d")))
                {
                animatejump();  
                }
                if(Greenfoot.isKeyDown("w") && Greenfoot.isKeyDown("a"))
                {
                 animatejumpl();   
                }
            } 
        }
        if(Greenfoot.isKeyDown("a"))
        {
            this.setLocation(this.getX() -5, this.getY());
            if(!Greenfoot.isKeyDown("w"))
            {
            if(animationCounter %3==0)
            animateL();
            }
        }
         if(Greenfoot.isKeyDown("d"))
        {
            this.setLocation(this.getX() +5, this.getY());
            if(!Greenfoot.isKeyDown("w"))
            {
            if(animationCounter %3==0)
            animateR();
            } 
        }
        if(Greenfoot.isKeyDown("d") && Greenfoot.isKeyDown("shift"))
        {
            this.setLocation(this.getX() +3, this.getY());
            if(!Greenfoot.isKeyDown("w"))
            {
            if(animationCounter %3==0)
            animateS();
            }
        }
        if(Greenfoot.isKeyDown("a") && Greenfoot.isKeyDown("shift"))
        {
            this.setLocation(this.getX() -3, this.getY());
            if(!Greenfoot.isKeyDown("w"))
            {
            if(animationCounter %3==0)
            animateSL();
            }
        }
        if(!Greenfoot.isKeyDown("d") && !Greenfoot.isKeyDown("a") && !Greenfoot.isKeyDown("w") )
        {
            if(animationCounter %15==0)
            animateI();
        }
    }
    public void falling()
    {
        this.setLocation(this.getX(), this.getY() + verticalSpeed);
        verticalSpeed = verticalSpeed +1;
    }
    public void checkFalling()
    {
        if(this.getY()>275 )
         {
            verticalSpeed= 0;
         }
        else
          {
           this.falling(); 
          }
       
    }
    public void animateR()
    {
        if(frame == 1)
        {
            setImage(run1r);
        }
        else if(frame == 2)
        {
            setImage(run2r);
        }
        else if(frame == 3)
        {
            setImage(run3r);
        }
        else if(frame == 4)
        {
            setImage(run4r);
            frame = 1;
            return;
        }
         frame ++;
    }
    public void animateL()
    {
        if(framel == 1)
        {
            setImage(run1l);
        }
        else if(framel == 2)
        {
            setImage(run2l);
        }
        else if(framel == 3)
        {
            setImage(run3l);
        }
        else if(framel == 4)
        {
            setImage(run4l);
            framel = 1;
            return;
        }
         framel ++;
    }
    public void jump()
    {
        verticalSpeed=-15;
        this.falling();
    }
    public void animateS()
    {
        if(frames == 1)
        {
            setImage(run1s);
        }
        else if(frames == 2)
        {
            setImage(run2s);
        }
        else if(frames == 3)
        {
            setImage(run3s);
        }
        else if(frames == 4)
        {
            setImage(run4s);
            frames = 1;
            return;
        }
         frames ++; 
    }
     public void animateSL()
    {
        if(framesl == 1)
        {
            setImage(run1sl);
        }
        else if(framesl == 2)
        {
            setImage(run2sl);
        }
        else if(framesl == 3)
        {
            setImage(run3sl);
        }
        else if(framesl == 4)
        {
            setImage(run4sl);
            framesl = 1;
            return;
        }
         framesl ++; 
    }
     public void animateI()
    {
        if(framei == 1)
        {
            setImage(idl1);
        }
        else if(framei == 2)
        {
            setImage(idl2);
        }
        else if(framei == 3)
        {
            setImage(idl3);
            framei = 1;
            return;
        }
         framei ++; 
    }
    public void animatejump()
    {
     setImage(jump1r);
     setImage(jumpr); 
    }
    public void animatejumpl()
    {
       setImage(jump1l); 
     
       setImage(jumpl); 
    }
    public void spawncoin()
    { 
        if(Greenfoot.getRandomNumber(coincounter) == 1)
        {
        Coin coin = new Coin();
        getWorld().addObject(coin, Greenfoot.getRandomNumber(700), Greenfoot.getRandomNumber(3));
        }
    }
    public void spawnbomb()
    {   
        if(Greenfoot.getRandomNumber(bombcounter)  == 1)
        {
        bomb bomb = new bomb();
        getWorld().addObject(bomb, Greenfoot.getRandomNumber(700), Greenfoot.getRandomNumber(3));
        }
    }
    public void bombexpl()
    {
       setImage("expl1.png");
       setImage("expl2.png");
       setImage("expl3.png");
       setImage("expl4.png");
    }
    public void heal()
    {   
        if(Greenfoot.getRandomNumber(healcounter) == 1)
        {
        heal heal = new heal();
        getWorld().addObject(heal, Greenfoot.getRandomNumber(700), Greenfoot.getRandomNumber(3));
        }
    }
}



